Bug 1007702 (skia-windows)

Enable skia content on Windows by default when not using D2D

RESOLVED FIXED in Firefox 52

Status

()

Core
Graphics
RESOLVED FIXED
3 years ago
a month ago

People

(Reporter: jrmuizel, Assigned: mchang)

Tracking

(Depends on: 2 bugs)

unspecified
mozilla52
x86
Windows XP
Points:
---
Dependency tree / graph

Firefox Tracking Flags

(firefox52 fixed)

Details

(Whiteboard: gfx-noted)

Attachments

(4 attachments, 4 obsolete attachments)

Comment hidden (empty)
(Reporter)

Updated

3 years ago
Depends on: 1007699, 1007700
(Reporter)

Updated

3 years ago
Depends on: 996611
(Reporter)

Updated

3 years ago
Depends on: 1010446
Depends on: 1002549
Blocks: 939709
Depends on: 994101
(Reporter)

Updated

3 years ago
Alias: skia-windows
(Reporter)

Updated

3 years ago
Depends on: 1029705
Depends on: 1062919
(Reporter)

Updated

3 years ago
Blocks: 1095510
I'm curious, why have we decided that we want to use Skia backed DTs on Windows? D2D backed DTs seem like they could be giving us good perf advantages over skia in at least some cases. See bug 841931 comment 12.

Maybe this bug's summary is a bit misleading and this is only about Windows XP and other Windows versions with blacklisted drivers?
OS: Mac OS X → Windows XP
(Reporter)

Updated

3 years ago
Summary: Enable skia content on Windows by default → Enable skia content on Windows by default when not using D2D
No longer blocks: 939709
Depends on: 939709
Blocks: 1186552

Updated

2 years ago
Depends on: 1200684
(Assignee)

Updated

a year ago
Duplicate of this bug: 1248740
(Assignee)

Updated

a year ago
Assignee: nobody → mchang
Whiteboard: gfx-noted
(Assignee)

Updated

a year ago
Duplicate of this bug: 772958
(Assignee)

Updated

a year ago
Depends on: 1278972
(Assignee)

Updated

a year ago
Depends on: 1279063
(Assignee)

Updated

a year ago
Depends on: 1279064
(Assignee)

Updated

11 months ago
Depends on: 1282626
(Assignee)

Updated

10 months ago
Depends on: 1218706
(Assignee)

Updated

10 months ago
Depends on: 1293759
(Assignee)

Comment 4

9 months ago
Created attachment 8784939 [details] [diff] [review]
Enable skia content for unaccelerated windows

Mostly reftest fuzzing. Can delete some tests due to https://bugzilla.mozilla.org/show_bug.cgi?id=1218706#c39
Attachment #8784939 - Flags: review?(lsalzman)

Updated

9 months ago
Attachment #8784939 - Flags: review?(lsalzman) → review+
(Assignee)

Comment 5

9 months ago
I think try is ok - https://treeherder.mozilla.org/#/jobs?repo=try&revision=61f73b3ed386&selectedJob=26138648 - all the gl stuff looks like known intermittents. Same with the mda. 

Here is a try all - https://treeherder.mozilla.org/#/jobs?repo=try&revision=eceeebed683b - The reftest suite crashing is bug 1267106.

Comment 6

9 months ago
Pushed by mchang@mozilla.com:
https://hg.mozilla.org/integration/mozilla-inbound/rev/209072396aa5
Enable skia on unaccelerated windows. r=lsalzman

Comment 7

9 months ago
bugherder
https://hg.mozilla.org/mozilla-central/rev/209072396aa5
Status: NEW → RESOLVED
Last Resolved: 9 months ago
status-firefox51: --- → fixed
Resolution: --- → FIXED
Target Milestone: --- → mozilla51

Updated

9 months ago
Depends on: 1298608

Updated

9 months ago
Blocks: 591822

Updated

9 months ago
Blocks: 1298511

Updated

9 months ago
Depends on: 1298484
Depends on: 1299204
Blocks: 1299605
Mason, following discussions with Milan earlier today, I have filed bug 1299605 to track A/B experimentation for this change. Please update that bug with any info you have, including technical details. Thank you.
Flags: needinfo?(mchang)

Comment 9

9 months ago
Can I ask a very silly question, please.
In Thunderbird on Windows 10 my monospace font looks very thin after this bug landed.
Is there a problem to remove "skia" from these preferences:
gfx.content.azure.backends
gfx.canvas.azure.backends
(Assignee)

Comment 10

9 months ago
Do you have screenshots of before and after please? If you run Firefox, do you see differences in fonts as well? IF so, can you please attach your about:support? Thanks!
Flags: needinfo?(mchang) → needinfo?(jorgk)

Comment 11

9 months ago
Created attachment 8786928 [details]
2016-08-31 22_26_26-Mozilla - Local Folders - Daily.png

Screenshot attached.
Left, TB compiled today, right, TB compiled 26/8 before this bug landed. You can see that left is noticeably thinner, not to say, disturbingly thinner. I removed "skia" from the two said preferences and it reverted back to the previous state.
If you want to know about my graphics setup, please ask. It's a Win 10 64bit system with an AMD A10-7860 APU, standard driver via Windows.

If you want, I can download a FF Nightly and compare it.
Flags: needinfo?(jorgk)
(Assignee)

Comment 12

9 months ago
(In reply to Jorg K (GMT+2, PTO during summer) from comment #11)
> Created attachment 8786928 [details]
> 2016-08-31 22_26_26-Mozilla - Local Folders - Daily.png
> 
> Screenshot attached.
> Left, TB compiled today, right, TB compiled 26/8 before this bug landed. You
> can see that left is noticeably thinner, not to say, disturbingly thinner. I
> removed "skia" from the two said preferences and it reverted back to the
> previous state.
> If you want to know about my graphics setup, please ask. It's a Win 10 64bit
> system with an AMD A10-7860 APU, standard driver via Windows.
> 
> If you want, I can download a FF Nightly and compare it.

Yes please. Can you please download Nightly and attach about:support here? Also when screenshotting, please screenshot the exact same text, otherwise it is quite hard to tell the difference with different text. Thanks.
Flags: needinfo?(jorgk)

Comment 13

9 months ago
I can't see any difference in FF 48 and FF 51 Nightly of today. However, TB looks different. I've raised bug 1299637 for that.
Flags: needinfo?(jorgk)

Comment 14

9 months ago
Created attachment 8786999 [details]
E-Mail exported as HTML and displayed in FF.

OK, I'm back. I finally found out what's going on. In FF 48 the text looks the same regardless of whether HWA is switched on or off. In FF 51 Nightly the text only looks good with HWA turned *on*.

Before I was comparing when HWA was switched on in both, comparing with HWA switched off in both shows the difference, see enclosed. Left: FF 48, right: FF 51.

So is it expected that having no HWA will degrade the font display somewhat?
Attachment #8786928 - Attachment is obsolete: true

Comment 15

9 months ago
Comment on attachment 8786999 [details]
E-Mail exported as HTML and displayed in FF.

Sorry, that looked like TB windows, but it's the e-mail exported to HTML and shown in FF.
Attachment #8786999 - Attachment description: 2016-09-01 01_45_34-Nightly.png → E-Mail exported as HTML and displayed in FF.
(Reporter)

Comment 16

9 months ago
Disabling HWA should change font rendering in FF48, but less so in Nightly with Skia enabled. Can you compare the font in Chrome and the situation where it's bad in Firefox?
Flags: needinfo?(jmuizelaar)
(Reporter)

Updated

9 months ago
Flags: needinfo?(jmuizelaar) → needinfo?(jorgk)
(Assignee)

Comment 17

9 months ago
I was getting the inverse. On Windows 10, with HWA off, both Cairo and Skia look thinner than D2D. However, with HWA off, Skia looks thicker than Cairo. What OS are you using? Are you on a hidpi monitor?
(Assignee)

Comment 18

9 months ago
Also, do you have cleartype enabled system wide?

Comment 19

9 months ago
Created attachment 8787086 [details]
about:support of FF 51

(In reply to Jeff Muizelaar [:jrmuizel] from comment #16)
> Disabling HWA should change font rendering in FF48, but less so in Nightly
> with Skia enabled.
That's not what I see. In FF 48, switching HWA off makes no difference, in FF 51 Nightly it makes a lot of difference.

> Can you compare the font in Chrome and the situation where it's bad in Firefox?
Chrome 53.0.2785.89 m (64-bit) looks as thin as FF 51, but the rendering is slightly better. The "2" in FF 51 almost lost its diagonal / downstroke, if you know what I mean, see screenshot. That's rendered better in Chrome.

(In reply to Mason Chang [:mchang] from comment #17)
> However, with HWA off, Skia looks thicker than Cairo.
Hmm, I assume that taking "skia" out of gfx.*.azure.backends disables it. Disabling it makes the font thicker.

> What OS are you using? Are you on a hidpi monitor?
As I said in comment #11: It's a Win 10 64bit system with an AMD A10-7860 APU, standard driver via Windows. The monitor is just 1280x1024.

(In reply to Mason Chang [:mchang] from comment #18)
> Also, do you have cleartype enabled system wide?
Yes.
Flags: needinfo?(jorgk)

Updated

9 months ago
Depends on: 1299738

Comment 20

9 months ago
(In reply to Jorg K (GMT+2, PTO during summer) from comment #19)
> (In reply to Jeff Muizelaar [:jrmuizel] from comment #16)
> > Disabling HWA should change font rendering in FF48, but less so in Nightly
> > with Skia enabled.
> That's not what I see. In FF 48, switching HWA off makes no difference, in
> FF 51 Nightly it makes a lot of difference.
I stand partly corrected. Some fonts are thinner without HWA in FF 48 than with HWA, but Courier New wasn't one of them. It only become thinner in FF 51 without HWA. You are also correct that, for example, the font 'Source Sans Pro' looks much better/thicker in FF 51 without HWA than in FF 48 without HWA.

However, the font used here for BMO, I assume it's Courier New, looks pretty thin/bad in FF 51 without HWA. This is also the font I use for monospace display in Thunderbird. So why has Courier New gone thinner when others have gone thicker without HWA?
(Assignee)

Comment 21

9 months ago
(In reply to Jorg K (GMT+2, PTO during summer) from comment #20)
> (In reply to Jorg K (GMT+2, PTO during summer) from comment #19)
> > (In reply to Jeff Muizelaar [:jrmuizel] from comment #16)
> > > Disabling HWA should change font rendering in FF48, but less so in Nightly
> > > with Skia enabled.
> > That's not what I see. In FF 48, switching HWA off makes no difference, in
> > FF 51 Nightly it makes a lot of difference.
> I stand partly corrected. Some fonts are thinner without HWA in FF 48 than
> with HWA, but Courier New wasn't one of them. It only become thinner in FF
> 51 without HWA. You are also correct that, for example, the font 'Source
> Sans Pro' looks much better/thicker in FF 51 without HWA than in FF 48
> without HWA.
> 
> However, the font used here for BMO, I assume it's Courier New, looks pretty
> thin/bad in FF 51 without HWA. This is also the font I use for monospace
> display in Thunderbird. So why has Courier New gone thinner when others have
> gone thicker without HWA?

Just a reminder for myself, this seems to be happening because of this - http://searchfox.org/mozilla-central/source/modules/libpref/init/all.js#3364
(Assignee)

Updated

9 months ago
Depends on: 1299903

Updated

9 months ago
Depends on: 1300025
Depends on: 1299985

Updated

9 months ago
Depends on: 1300498
(Assignee)

Updated

9 months ago
Depends on: 1302225
Depends on: 1302240
We backed this out in bug 1302225, so reopen. We will be running some telemetry experiments to compare stability of Skia and Cairo, and may have to enable Skia by default during that time.
Andrew, can you get/land a patch to re-enable Skia by default on Windows nightly (basically, back out the backout from bug 1302225)?
Status: RESOLVED → REOPENED
Flags: needinfo?(aosmond)
Resolution: FIXED → ---
Created attachment 8793418 [details] [diff] [review]
Re-enable skia on nightly for unaccelerated windows, v1, r=me

Comment 24

8 months ago
Pushed by aosmond@gmail.com:
https://hg.mozilla.org/integration/mozilla-inbound/rev/c7f7f5bee4a7
Enable skia on nighly for unaccelerated windows. r=me
Flags: needinfo?(aosmond)
Backed out for (wr) failures on Windows: https://hg.mozilla.org/integration/mozilla-inbound/rev/b17d72b15baa

https://treeherder.mozilla.org/logviewer.html#?job_id=36232686&repo=mozilla-inbound
Flags: needinfo?(mchang)
Flags: needinfo?(aosmond)
Created attachment 8793477 [details] [diff] [review]
Re-enable skia on nightly for unaccelerated windows, v2

Fix the reftests/wpt failures.
Attachment #8793418 - Attachment is obsolete: true
Flags: needinfo?(mchang)
Flags: needinfo?(aosmond)
Attachment #8793477 - Flags: review?(lsalzman)
Created attachment 8793487 [details] [diff] [review]
Re-enable skia on nightly for unaccelerated windows, v3
Attachment #8793477 - Attachment is obsolete: true
Attachment #8793477 - Flags: review?(lsalzman)
Attachment #8793487 - Flags: review?(lsalzman)

Updated

8 months ago
Attachment #8793487 - Flags: review?(lsalzman) → review+
Let's make sure this time...

try: https://treeherder.mozilla.org/#/jobs?repo=try&revision=3980e6cd8c7c

Updated

8 months ago
status-firefox51: fixed → ---
Target Milestone: mozilla51 → ---
Created attachment 8793769 [details] [diff] [review]
Re-enable skia on nightly for unaccelerated windows, v4

Whoops it should have been disabled instead of expected.

try: https://treeherder.mozilla.org/#/jobs?repo=try&revision=a16eb4802a12
Attachment #8793487 - Attachment is obsolete: true
Alright good to go this time (for these failures in any event).

Windows 7 skips the tests:

07:41:16     INFO - TEST-SKIP | /html/dom/elements/requirements-relating-to-bidirectional-algorithm-formatting-characters/dir-isolation-002a.html | took 1ms
07:41:16     INFO - TEST-SKIP | /html/dom/elements/requirements-relating-to-bidirectional-algorithm-formatting-characters/dir-isolation-002b.html | took 0ms
07:41:16     INFO - TEST-SKIP | /html/dom/elements/requirements-relating-to-bidirectional-algorithm-formatting-characters/dir-isolation-002c.html | took 0ms
07:41:16     INFO - TEST-SKIP | /html/dom/elements/requirements-relating-to-bidirectional-algorithm-formatting-characters/dir-isolation-006a.html | took 0ms
07:41:16     INFO - TEST-SKIP | /html/dom/elements/requirements-relating-to-bidirectional-algorithm-formatting-characters/dir-isolation-006b.html | took 0ms
07:41:16     INFO - TEST-SKIP | /html/dom/elements/requirements-relating-to-bidirectional-algorithm-formatting-characters/dir-isolation-006c.html | took 1ms
07:41:16     INFO - TEST-SKIP | /html/dom/elements/requirements-relating-to-bidirectional-algorithm-formatting-characters/dir-isolation-009a.html | took 0ms
07:41:16     INFO - TEST-SKIP | /html/dom/elements/requirements-relating-to-bidirectional-algorithm-formatting-characters/dir-isolation-009b.html | took 0ms
07:41:16     INFO - TEST-SKIP | /html/dom/elements/requirements-relating-to-bidirectional-algorithm-formatting-characters/dir-isolation-009c.html | took 0ms

Linux runs the tests and they pass:

[task 2016-09-22T13:21:56.639549Z] 13:21:56     INFO - TEST-PASS | /html/dom/elements/requirements-relating-to-bidirectional-algorithm-formatting-characters/dir-isolation-002a.html | took 2042ms
[task 2016-09-22T13:21:58.896689Z] 13:21:58     INFO - TEST-PASS | /html/dom/elements/requirements-relating-to-bidirectional-algorithm-formatting-characters/dir-isolation-002b.html | took 2208ms
[task 2016-09-22T13:22:01.641469Z] 13:22:01     INFO - TEST-PASS | /html/dom/elements/requirements-relating-to-bidirectional-algorithm-formatting-characters/dir-isolation-002c.html | took 2730ms
[task 2016-09-22T13:22:24.688415Z] 13:22:24     INFO - TEST-PASS | /html/dom/elements/requirements-relating-to-bidirectional-algorithm-formatting-characters/dir-isolation-006a.html | took 2421ms
[task 2016-09-22T13:22:26.567621Z] 13:22:26     INFO - TEST-PASS | /html/dom/elements/requirements-relating-to-bidirectional-algorithm-formatting-characters/dir-isolation-006b.html | took 1860ms
[task 2016-09-22T13:22:29.250281Z] 13:22:29     INFO - TEST-PASS | /html/dom/elements/requirements-relating-to-bidirectional-algorithm-formatting-characters/dir-isolation-006c.html | took 2678ms
[task 2016-09-22T13:22:50.396671Z] 13:22:50     INFO - TEST-PASS | /html/dom/elements/requirements-relating-to-bidirectional-algorithm-formatting-characters/dir-isolation-009a.html | took 6726ms
[task 2016-09-22T13:22:53.579234Z] 13:22:53     INFO - TEST-PASS | /html/dom/elements/requirements-relating-to-bidirectional-algorithm-formatting-characters/dir-isolation-009b.html | took 3178ms
[task 2016-09-22T13:22:55.636287Z] 13:22:55     INFO - TEST-PASS | /html/dom/elements/requirements-relating-to-bidirectional-algorithm-formatting-characters/dir-isolation-009c.html | took 2014ms

Comment 31

8 months ago
Pushed by aosmond@gmail.com:
https://hg.mozilla.org/integration/mozilla-inbound/rev/729307f6ac59
Enable skia on nighly for unaccelerated windows. r=lsalzman

Updated

8 months ago
Depends on: 1304967

Comment 32

8 months ago
bugherder
https://hg.mozilla.org/mozilla-central/rev/729307f6ac59
Status: REOPENED → RESOLVED
Last Resolved: 9 months ago8 months ago
status-firefox52: --- → fixed
Resolution: --- → FIXED
Target Milestone: --- → mozilla52

Comment 33

8 months ago
bugherder
https://hg.mozilla.org/mozilla-central/rev/729307f6ac59
Blocks: 1197498

Comment 34

8 months ago
Pushed by ryanvm@gmail.com:
https://hg.mozilla.org/integration/mozilla-inbound/rev/5660f036b020
Tweak the reftest annotations to account for Windows 10 with Skia.

Comment 35

8 months ago
bugherder
https://hg.mozilla.org/mozilla-central/rev/5660f036b020
Depends on: 1314090
(Assignee)

Updated

6 months ago
Depends on: 1321901
Depends on: 1315568

Updated

3 months ago
Depends on: 1345222

Updated

3 months ago
Depends on: 1345399

Comment 36

a month ago
Yesterday I upgraded from FF51 to FF52 on Win7 SP1 on my "old" Dell Latitude D610 (blocklisted Intel 910/915),
and was very pleasantly surprised by the improved appearance of various fonts on various websites.  Curious as
to why, I then found out (in the FF52 Release Notes) about the new exploitation of Skia in FF52.  This Comment
is to thank everybody involved in the decision to exploit Skia, and also those involved in its implementation.
Thank you all very much!
(Assignee)

Comment 37

a month ago
(In reply to Bob Hill from comment #36)
> Yesterday I upgraded from FF51 to FF52 on Win7 SP1 on my "old" Dell Latitude
> D610 (blocklisted Intel 910/915),
> and was very pleasantly surprised by the improved appearance of various
> fonts on various websites.  Curious as
> to why, I then found out (in the FF52 Release Notes) about the new
> exploitation of Skia in FF52.  This Comment
> is to thank everybody involved in the decision to exploit Skia, and also
> those involved in its implementation.
> Thank you all very much!

Thank you! A positive comment is a great and rare treasure :).
You need to log in before you can comment on or make changes to this bug.